<template>
  <v-datetime-picker
    v-if="showTime"
    v-model="formattedDatetime"
    :label="$props.label ? 'datetime' : null"
    :text-field-props="computedTextFieldProps"
    :date-picker-props="datePickerProps"
    min="2020-04-01"
    :max="dateNow"
    v-bind="{disabled}"
    time-format="HH:mm:ss"
  >
    <template v-slot:activator="{ on }">
      <span
        class="hud--date"
        v-on="on"
      >{{ formattedDatetime }}</span>
    </template>
  </v-datetime-picker>

  <v-menu
    v-else
    ref="menu"
    v-model="isDatepickerOpen"
    :close-on-content-click="false"
    :return-value.sync="formattedDatetime"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template
      v-slot:activator="{ on }"
      v-bind="computedTextFieldProps"
    >
      <v-text-field
        v-model="formattedDatetime"
        v-bind="computedTextFieldProps"
        v-on="on"
      />
    </template>
    <v-date-picker
      v-model="formattedDatetime"
      no-title
      scrollable
      v-bind="datePickerProps"
    >
      <v-spacer />
      <v-btn
        text
        color="primary"
        @click="isDatepickerOpen = false"
      >
        Cancel
      </v-btn>
      <v-btn
        text
        color="primary"
        @click="$refs.menu.save(formattedDatetime)"
      >
        OK
      </v-btn>
    </v-date-picker>
  </v-menu>
</template>

<script>
  import moment from 'moment-timezone'
  import { mapState } from 'vuex'
  import { mutations } from '../store/constants'

  // const formatDatetime = 'yyyy-MM-DD HH:mm:s'
  const formatDate = 'yyyy-MM-DD'

  export default {
    name: 'MetrocheckDatetimeDisplayedPicker',

    props: {
      textFieldProps: { required: false, default: () => ({}), type: Object },
      label: { required: false, default: false, type: Boolean },
      disabled: { required: false, type: Boolean },
      showTime: { required: false, type: Boolean, default: true },
    },

    data: function () {
      return {
        isDatepickerOpen: false,
      }
    },

    computed: {
      ...mapState(['displayedDatetime', 'allowedDates']),

      dateNow: () => moment().format(formatDate),

      formattedDatetime: {
        get: function () {
          return moment(this.displayedDatetime).format(this.$props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD')
        },
        set: function (val) { return this.$store.commit(mutations.SET_DISPLAYED_DATETIME, val ? moment(val).valueOf() : Date.now()) },
      },

      datePickerProps: function () {
        return { allowedDates: val => this.allowedDates.includes(val) }
      },
      computedTextFieldProps: function () {
        return { dense: true, ...this.$props.textFieldProps }
      },
    },

  }
</script>
